#include <iostream>
#include <Collage/types/model.h>

void Model::loadOBJ(const std::string& filename) {
    std::ifstream file(filename);
    std::vector<Vector3> positions;
    std::vector<Vector2> uvs;
    TextureInformation tInfo = {};
    std::string line;
    while (std::getline(file, line)) {
        std::istringstream stream(line);
        std::string prefix;
        stream >> prefix;

        if (prefix == "v") {
            float x, y, z;
            stream >> x >> y >> z;
            positions.emplace_back(x, y, z);
        } else if (prefix == "vt") {
            float u, v;
            stream >> u >> v;
            uvs.emplace_back(u, v);
        } else if (prefix == "f") {
            unsigned int vertexIndex[3], texCoordIndex[3];
            char slash;
            for (int i = 0; i < 3; ++i) {
                stream >> vertexIndex[i] >> slash >> texCoordIndex[i];
                vertexIndex[i]--;
                texCoordIndex[i]--;
            }

            for (int i = 0; i < 3; ++i) {
                Vertex vertex;
                Vector2 textureCoordinate;
                vertex = positions[vertexIndex[i]];
                textureCoordinate = uvs[texCoordIndex[i]];
                vertices.push_back(vertex);
                tInfo.textureCoordinates.push_back(textureCoordinate);
                indices.push_back(static_cast<unsigned int>(indices.size()));
            }
        }
    }
    textureInfo.push_back(tInfo);
    file.close();
};